-- settings ==============================================================================================================
	local version = "v2.07 (25-01-2011)";
	local soundpath = "Interface\\AddOns\\Killshot\\sounds\\";
	local currentSavedVar = 2;
	local maxAnnounces = 4;
	local timePerAnnounce = 15;
	local timeBetweenReceives = 0.3;
	local timeBeforeLastDamageDealerResets = 5.0;
	local audiofiles = 14;
-- settings ==============================================================================================================


-- init vars =============================================================================================================
	local loaded = 0;
	local announces = 0;
	local lastAnnounceCheckTime = GetTime();
	local lastTextReceivedFrom = "";
	local lastTextReceivedTime = GetTime();
	local lastSoundReceivedFrom = "";
	local lastSoundReceivedTime = GetTime();
	local lastDamageDealer = "";
	local lastDamageDealerTimeAgo = GetTime();
	local killingstreakPvE = 0;
-- init vars =============================================================================================================


-- load vars =============================================================================================================
	local frame = CreateFrame("FRAME");
	frame:RegisterEvent("ADDON_LOADED");
	
	function frame:OnEvent(event)
		if (event == "ADDON_LOADED") then
			if (loaded == 0) then
				loaded = 1;
				if (saved == currentSavedVar) then
					kshot:Print("Killshot preferences are loaded. "); 
					if (killingstreak == nil) then
						killingstreak = 0;
						kshot:Print("Loaded killingstreak = nil, changed it to [0]");
					end
					if (soundpack == nil) then
						soundpack = "normal";
						kshot:Print("Loaded soundpack = nil, changed it to [sp1normal]");
					end
					if (killingblowMessage == nil) then
						killingblowMessage = "pwned $v! Streak of $s!";
						kshot:Print("Loaded killingblowMessage = nil, changed it to [pwned $v! Streak of $s!]");
					end
					if (sound == nil) then
						sound = true;
						kshot:Print("Loaded sound = nil, changed it to [true]");
					end
					if (scrollingtext == nil) then
						scrollingtext = true;
						kshot:Print("Loaded scrollingtext = nil, changed it to [true]");
					end
					if (emote == nil) then
						emote = true;
						kshot:Print("Loaded emote = nil, changed it to [true]");
					end
					if (solo == nil) then
						solo = false;
						kshot:Print("Loaded solo = nil, changed it to [false]");
					end
					if (maxkillingstreak == nil) then
						maxkillingstreak = 0;
						kshot:Print("Loaded maxkillingstreak = nil, changed it to [0]");
					end
					if (totalkillingblows == nil) then
						totalkillingblows = 0;
						kshot:Print("Loaded totalkillingblows = nil, changed it to [0]");
					end
					if (killingstreaktimes == nil) then
						killingstreaktimes = 0;
						kshot:Print("Loaded killingstreaktimes = nil, changed it to [0]");
					end
					if (CheckVersionGuild == nil) then
						CheckVersionGuild = true;
						kshot:Print("Loaded CheckVersionGuild = nil, changed it to [true]");
					end
					if (CheckVersionRaid == nil) then
						CheckVersionRaid = true;
						kshot:Print("Loaded CheckVersionRaid = nil, changed it to [true]");
					end
					if (CheckVersionBG == nil) then
						CheckVersionBG = true;
						kshot:Print("Loaded CheckVersionBG = nil, changed it to [true]");
					end
					if (SendToGuild == nil) then
						SendToGuild = true;
						kshot:Print("Loaded SendToGuild = nil, changed it to [true]");
					end
					if (SendToRaid == nil) then
						SendToRaid = true;
						kshot:Print("Loaded SendToRaid = nil, changed it to [true]");
					end
					if (SendToBG == nil) then
						SendToBG = true;
						kshot:Print("Loaded SendToBG = nil, changed it to [true]");
					end
					if (ReceiveFromGuild == nil) then
						ReceiveFromGuild = true;
						kshot:Print("Loaded ReceiveFromGuild = nil, changed it to [true]");
					end
					if (ReceiveFromRaid == nil) then
						ReceiveFromRaid = true;
						kshot:Print("Loaded ReceiveFromRaid = nil, changed it to [true]");
					end
					if (ReceiveFromBG == nil) then
						ReceiveFromBG = true;
						kshot:Print("Loaded ReceiveFromBG = nil, changed it to [true]");
					end
					if (sendwhat == nil) then
						sendwhat = "streak";
						kshot:Print("Loaded sendwhat = nil, changed it to [streak1]");
					end
					if (StreakAnnounceGuild == nil) then
						StreakAnnounceGuild = true;
						kshot:Print("Loaded StreakAnnounceGuild = nil, changed it to [true]");
					end
					if (StreakAnnounceRaid == nil) then
						StreakAnnounceRaid = true;
						kshot:Print("Loaded StreakAnnounceRaid = nil, changed it to [true]");
					end
					if (StreakAnnounceBG == nil) then
						StreakAnnounceBG = true;
						kshot:Print("Loaded StreakAnnounceBG = nil, changed it to [true]");
					end
					if (YourDeathMessages == nil) then
						YourDeathMessages = true;
						kshot:Print("Loaded YourDeathMessages = nil, changed it to [true]");
					end
					if (YourDeathSounds == nil) then
						YourDeathSounds = true;
						kshot:Print("Loaded YourDeathSounds = nil, changed it to [true]");
					end
					if (OtherDeathMessages == nil) then
						OtherDeathMessages = true;
						kshot:Print("Loaded OtherDeathMessages = nil, changed it to [true]");
					end
					if (OtherDeathSounds == nil) then
						OtherDeathSounds = true;
						kshot:Print("Loaded OtherDeathSounds = nil, changed it to [true]");
					end
					if (ReceiveDeathsFromGuild == nil) then
						ReceiveDeathsFromGuild = true;
						kshot:Print("Loaded ReceiveDeathsFromGuild = nil, changed it to [true]");
					end
					if (ReceiveDeathsFromRaid == nil) then
						ReceiveDeathsFromRaid = true;
						kshot:Print("Loaded ReceiveDeathsFromRaid = nil, changed it to [true]");
					end
					if (ReceiveDeathsFromBG == nil) then
						ReceiveDeathsFromBG = true;
						kshot:Print("Loaded ReceiveDeathsFromBG = nil, changed it to [true]");
					end
					if (ResetStreakOnLogin == nil) then
						ResetStreakOnLogin = false;
						kshot:Print("Loaded ResetStreakOnLogin = nil, changed it to [false]");
					end
					if (ResetStreakOnZoneChange == nil) then
						ResetStreakOnZoneChange = false;
						kshot:Print("Loaded ResetStreakOnZoneChange = nil, changed it to [false]");
					end
					if (PvP == nil) then
						PvP = true;
						kshot:Print("Loaded PvP = nil, changed it to [true]");
					end
					if (PvE == nil) then
						PvE = false;
						kshot:Print("Loaded PvE = nil, changed it to [false]");
					end
					if (PvE_Random == nil) then
						PvE_Random = false;
						kshot:Print("Loaded PvE_Random = nil, changed it to [false]");
					end
					
					
					if (ResetStreakOnLogin == true) then
						kshot:ResetStreak();
					else
						kshot:ZoneChangedHandler();
					end
					
				else
					kshot:ResetAll();
				end
			end
		end
	end

	frame:SetScript("OnEvent", frame.OnEvent);
	kshot = LibStub("AceAddon-3.0"):NewAddon("kshot", "AceEvent-3.0", "AceConsole-3.0", "LibSink-2.0");
-- load vars =============================================================================================================


-- window ================================================================================================================
	local function makeInfo() 
		local array = { 
			type = "group",
			name = "Killshot",
			args = {
				info_version = {
					type = "description",
					name = version .. "\n\n\nCurrent killing streak: " .. killingstreak .. "\nHighest killing streak: " .. maxkillingstreak .. "\nAverage killing streak: " .. kshot:getStreakAverage() .. "\n\nTotal amount of killingblows: " .. totalkillingblows .. "\nAmount of killingstreaks: " .. killingstreaktimes .. "\n\n",
					order = 10
				},
				info_streakreset = {
					type = 'execute',
					name = 'Reset Current Streak',
					func = function() kshot:ResetStreak() end,
					width = "full",
					order = 20
				},
				info_streakresetall = {
					type = 'execute',
					name = 'Reset Streak Stats',
					func = function() kshot:ResetStreakInfo() end,
					width = "full",
					order = 30
				},
				info_resetall = {
					type = 'execute',
					name = 'Reset All Settings',
					func = function() kshot:ResetAll() end,
					width = "full",
					order = 40
				}
			}
		}
		return array;
	end
	
	local function makeSettings() 
		local array = { 
			type = "group",
			name = "Settings",
			args = {
				settings_test = {
					type = 'execute',
					name = 'Killshot Test',
					func = function() kshot:Test() end,
					width = "full",
					order = 10
				},
				settings_soundpack = {
					type = 'select',
					name = 'Select Soundpack',
					desc = 'Select Soundpack',
					get = function() return soundpack end,
					set = function(info, var) soundpack = var end,
					values = {
						sp1normal = "1. Normal",
						sp2female = "2. Female",
						sp3sexy = "3. Sexy",
						sp4custom = "4. Custom"
					},
					order = 20
				},
				settings_msg = {
					type = 'input',
					name = 'Killingblow Message',
					desc = "$v = victim, $s = streak",
					usage = "<message>",
					get = function() return killingblowMessage end,
					set = function(info, var) killingblowMessage = var end,
					width = "full",
					order = 30
				},
				settings_emote = {
					type = 'toggle',
					name = 'Enable all Emote Messages',
					get = function() return emote end,
					set = function(info, var) emote = var end,
					width = "full",
					order = 40
				},
				settings_scrollingtext = {
					type = 'toggle',
					name = 'Enable all Scrolling Text Messages',
					get = function() return scrollingtext end,
					set = function(info, var) scrollingtext = var end,
					width = "full",
					order = 50
				},
				settings_sound = {
					type = 'toggle',
					name = 'Enable all Sounds',
					get = function() return sound end,
					set = function(info, var) sound = var end,
					width = "full",
					order = 60
				},
				settings_empty_line_1 = {
					type = "description",
					name = "\n",
					order = 70
				},
				settings_description_pvp_pve = {
					type = "description",
					name = "PvE kills will only play a sound. PvE kills won't share, and they won't modify your streak-data. ",
					order = 80
				},
				settings_pvp = {
					type = 'toggle',
					name = 'Enable PvP Kills',
					get = function() return PvP end,
					set = function(info, var) PvP = var end,
					width = "full",
					order = 90
				},
				settings_pve = {
					type = 'toggle',
					name = "Enable PvE Kills",
					get = function() return PvE end,
					set = function(info, var) PvE = var end,
					width = "full",
					order = 100
				},
				settings_pve_random = {
					type = 'toggle',
					name = "PvE kills play random sounds",
					get = function() return ((PvE_Random == true) and (PvE == true)) end,
					set = function(info, var) PvE_Random = var end,
					width = "full",
					order = 110
				},
				settings_empty_line_2 = {
					type = "description",
					name = "\n",
					order = 120
				},
				settings_resetstreakonlogin = {
					type = 'toggle',
					name = 'Reset your streak on login',
					get = function() return ResetStreakOnLogin end,
					set = function(info, var) ResetStreakOnLogin = var end,
					width = "full",
					order = 130
				},
				settings_resetstreakonzonechange = {
					type = 'toggle',
					name = 'Reset your streak on zone change',
					get = function() return ResetStreakOnZoneChange end,
					set = function(info, var) ResetStreakOnZoneChange = var end,
					width = "full",
					order = 140
				},
				settings_empty_line_3 = {
					type = "description",
					name = "\n",
					order = 150
				},
				settings_yourdeathmessages = {
					type = 'toggle',
					name = 'Enable your Death Messages',
					get = function() return ((YourDeathMessages == true) and (scrollingtext == true)) end,
					set = function(info, var) YourDeathMessages = var end,
					width = "full",
					order = 160
				},
				settings_yourdeathsounds = {
					type = 'toggle',
					name = 'Enable your Death Sounds',
					get = function() return ((YourDeathSounds == true) and (sound == true)) end,
					set = function(info, var) YourDeathSounds = var end,
					width = "full",
					order = 170
				},
				settings_otherdeathmessages = {
					type = 'toggle',
					name = 'Enable others Death Messages',
					get = function() return ((OtherDeathMessages == true) and (scrollingtext == true) and (solo == false)) end,
					set = function(info, var) OtherDeathMessages = var end,
					width = "full",
					order = 180
				},
				settings_otherdeathsounds = {
					type = 'toggle',
					name = 'Enable others Death Sounds',
					get = function() return ((OtherDeathSounds == true) and (sound == true) and (solo == false)) end,
					set = function(info, var) OtherDeathSounds = var end,
					width = "full",
					order = 190
				}
			}
		}
		return array;
	end
	
	local function makeKillsShareSettings() 
		local array = { 
			type = "group",
			name = "Kills Share Settings",
			args = {
				kss_solo = {
					type = 'toggle',
					name = 'Solo Mode (blocks all sending/receiving)',
					get = function() return solo end,
					set = function(info, var) solo = var end,
					width = "full",
					order = 10
				},
				kss_empty_line_1 = {
					type = "description",
					name = "\n",
					order = 20
				},
				kss_sendguild = {
					type = 'toggle',
					name = 'Send kills to Guild',
					get = function() return ((SendToGuild == true) and (solo == false)) end,
					set = function(info, var) SendToGuild = var end,
					width = "full",
					order = 30
				},
				kss_sendraid = {
					type = 'toggle',
					name = 'Send kills to Party/Raid',
					get = function() return ((SendToRaid == true) and (solo == false)) end,
					set = function(info, var) SendToRaid = var end,
					width = "full",
					order = 40
				},
				kss_sendbg = {
					type = 'toggle',
					name = 'Send kills to BG',
					get = function() return ((SendToBG == true) and (solo == false)) end,
					set = function(info, var) SendToBG = var end,
					width = "full",
					order = 50
				},
				kss_empty_line_2 = {
					type = "description",
					name = "\n",
					order = 60
				},
				kss_receiveguild = {
					type = 'toggle',
					name = 'Receive kills from Guild',
					get = function() return ((ReceiveFromGuild == true) and (solo == false)) end,
					set = function(info, var) ReceiveFromGuild = var end,
					width = "full",
					order = 70
				},
				kss_receiveraid = {
					type = 'toggle',
					name = 'Receive kills from Party/Raid',
					get = function() return ((ReceiveFromRaid == true) and (solo == false)) end,
					set = function(info, var) ReceiveFromRaid = var end,
					width = "full",
					order = 80
				},
				kss_receivebg = {
					type = 'toggle',
					name = 'Receive kills from BG',
					get = function() return ((ReceiveFromBG == true) and (solo == false)) end,
					set = function(info, var) ReceiveFromBG = var end,
					width = "full",
					order = 90
				},
				kss_empty_line_3 = {
					type = "description",
					name = "\n",
					order = 100
				},
				kss_receivedeathsguild = {
					type = 'toggle',
					name = 'Receive deaths from Guild',
					get = function() return ((ReceiveDeathsFromGuild == true) and (solo == false)) end,
					set = function(info, var) ReceiveDeathsFromGuild = var end,
					width = "full",
					order = 110
				},
				kss_receivedeathsraid = {
					type = 'toggle',
					name = 'Receive deaths from Party/Raid',
					get = function() return ((ReceiveDeathsFromRaid == true) and (solo == false)) end,
					set = function(info, var) ReceiveDeathsFromRaid = var end,
					width = "full",
					order = 120
				},
				kss_receivedeathsbg = {
					type = 'toggle',
					name = 'Receive deaths from BG',
					get = function() return ((ReceiveDeathsFromBG == true) and (solo == false)) end,
					set = function(info, var) ReceiveDeathsFromBG = var end,
					width = "full",
					order = 130
				}
			}
		}
		return array;
	end
	
	local function makeCompareVersions() 
		local array = { 
			type = "group",
			name = "Compare Versions",
			args = {
				version_guild = {
					type = 'toggle',
					name = 'Guild',
					get = function() return CheckVersionGuild end,
					set = function(info, var) CheckVersionGuild = var end,
					width = "full",
					order = 10
				},
				version_raid = {
					type = 'toggle',
					name = 'Party/Raid',
					get = function() return CheckVersionRaid end,
					set = function(info, var) CheckVersionRaid = var end,
					width = "full",
					order = 20
				},
				version_bg = {
					type = 'toggle',
					name = 'BG',
					get = function() return CheckVersionBG end,
					set = function(info, var) CheckVersionBG = var end,
					width = "full",
					order = 30
				},
				version_check = {
					type = 'execute',
					name = 'Compare your version with others',
					func = function() kshot:CheckVersions(CheckVersionGuild, CheckVersionRaid, CheckVersionBG) end,
					width = "full",
					order = 40
				}
			}
		}
		return array;
	end
	
	local function makeStreakAnnouncements() 
		local array = { 
			type = "group",
			name = "Announce Streak Data",
			args = {
				sa_sendwhat = {
					type = 'select',
					name = 'Select Data to Send',
					desc = 'Select Data to Send',
					get = function() return sendwhat end,
					set = function(info, var) sendwhat = var end,
					values = {
						streak1 = "Current Streak",
						streak2max = "Highest Streak",
						streak3avg = "Average Streak"
					},
					order = 10
				},
				sa_guild = {
					type = 'toggle',
					name = 'Guild',
					get = function() return StreakAnnounceGuild end,
					set = function(info, var) StreakAnnounceGuild = var end,
					width = "full",
					order = 20
				},
				sa_raid = {
					type = 'toggle',
					name = 'Party/Raid',
					get = function() return StreakAnnounceRaid end,
					set = function(info, var) StreakAnnounceRaid = var end,
					width = "full",
					order = 30
				},
				sa_bg = {
					type = 'toggle',
					name = 'BG',
					get = function() return StreakAnnounceBG end,
					set = function(info, var) StreakAnnounceBG = var end,
					width = "full",
					order = 40
				},
				sa_send = {
					type = 'execute',
					name = 'Send',
					func = function() kshot:EchoStreakData(sendwhat, StreakAnnounceGuild, StreakAnnounceRaid, StreakAnnounceBG) end,
					width = "full",
					order = 50
				}
			}
		}
		return array;
	end
	
	local function makeAbout() 
		local array = { 
			type = "group",
			name = "About",
			args = {
				about_about = {
					type = "description",
					name = "Author: Zwarmapapa \nE-Mail: zwarmapapa@hotmail.com \nWebsite: zwarmapapa.nl \n\nPlaying Horde on Ahn'Qiraj\nFeel free to add me ingame",
					order = 10
				}
			}
		}
		return array;
	end
	

	function kshot:OnInitialize()
		local window = LibStub("AceConfigRegistry-3.0");
		window:RegisterOptionsTable("Killshot", makeInfo);
		window:RegisterOptionsTable("Killshot Settings", makeSettings);
		window:RegisterOptionsTable("Killshot Kills Share Settings", makeKillsShareSettings);
		window:RegisterOptionsTable("Killshot Compare Versions", makeCompareVersions);
		window:RegisterOptionsTable("Killshot Announce Streak Data", makeStreakAnnouncements);
		window:RegisterOptionsTable("Killshot About", makeAbout);
		
		local panel = LibStub("AceConfigDialog-3.0");
		panel:AddToBlizOptions("Killshot", "Killshot");
		panel:AddToBlizOptions("Killshot Settings", "Settings", "Killshot");
		panel:AddToBlizOptions("Killshot Kills Share Settings", "Kills Share Settings", "Killshot");
		panel:AddToBlizOptions("Killshot Compare Versions", "Compare Versions", "Killshot");
		panel:AddToBlizOptions("Killshot Announce Streak Data", "Announce Streak Data", "Killshot");
		panel:AddToBlizOptions("Killshot About", "About", "Killshot");
		
		
		self:RegisterChatCommand("killshot", function() InterfaceOptionsFrame_OpenToCategory("Killshot") end)
		self:RegisterChatCommand("kshot", function() InterfaceOptionsFrame_OpenToCategory("Killshot") end)
		self:RegisterChatCommand("ks", function() InterfaceOptionsFrame_OpenToCategory("Killshot") end)
	end
-- window ================================================================================================================


-- needed crap ===========================================================================================================
	function kshot:OnEnable()
		self:RegisterEvent("SoundEvent", "SoundEventHandler");
		self:RegisterEvent("CHAT_MSG_ADDON", "AddonMessageHandler");
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEventHandler");
		self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "ZoneChangedHandler");
	end
	function kshot:SoundEventHandler(sound)
		if not (PlaySoundFile(sound)) then
			self:ScheduleEvent("SoundEvent", 0.2, sound);
		end
	end
	function kshot:ZoneChangedHandler()
		if (ResetStreakOnZoneChange == true) then
			kshot:ResetSreak();
		elseif (killingstreak > 0) then
			kshot:EchoStreak1();
		end
	end
	function kshot:EchoStreak1()
		kshot:EchoStreak(true, false, false, false);
	end
	function kshot:EchoMaxStreak1()
		kshot:EchoMaxStreak(true, false, false, false);
	end
	function kshot:EchoAverageStreak1()
		kshot:EchoAverageStreak(true, false, false, false);
	end
	function kshot:ScrollText(msg, force)
		if ((scrollingtext == true) or (force == true)) then
			if (IsAddOnLoaded("Blizzard_CombatText")) then 
				CombatText_AddMessage(msg, CombatText_StandardSCroll, 1, 0.1, 0.1, "crit", 0);        
			elseif (IsAddOnLoaded("SCT")) then 
				SCT:DisplayText(msg, {r=1.0, g=0.1, b=0.1}, 1, "event", 1, 1);
			end
		end
		kshot:Print(msg);
	end
	function kshot:SendVersionResponse(requester, targetGroup)
		SendAddonMessage("kshot_VersionCheckResponse", requester .. ":" .. UnitName("player") .. " is on version " .. version, targetGroup);
	end
	function kshot:CheckGuildVersions()
		SendAddonMessage("kshot_Guild_VersionCheckRequest", UnitName("player"), "GUILD");
	end
	function kshot:CheckRaidVersions()
		SendAddonMessage("kshot_Raid_VersionCheckRequest", UnitName("player"), "RAID");
	end
	function kshot:CheckBGVersions()
		SendAddonMessage("kshot_BG_VersionCheckRequest", UnitName("player"), "BATTLEGROUND");
	end
	function kshot:PlaySound(soundfilelink)
		if (sound == true) then
			local soundfile = soundpath .. soundfilelink;
			kshot:SoundEventHandler(soundfile);
		end
	end
	function kshot:GetMessageGroup()
		local targetGroup = "RAID";
		if (kshot:IsInBattleground() == true) then
			targetGroup = "BATTLEGROUND";
		end
		return targetGroup;
	end
	function kshot:IsInBattleground()
		local inBG = false;
		local zone = GetZoneText();
		if ((zone == "Warsong Gulch") or (zone == "Eye of the Storm") or (zone == "Arathi Basin") or (zone == "Alterac Valley") or (zone == "Halaa") or (zone == "Wintergrasp") or (zone == "Strand of the Ancients") or (zone == "Isle of Conquest") or (zone == "Dalaran Arena") or (zone ==  "Nagrand Arena") or (zone == "Blade's Edge Arena") or (zone == "The Ring of Valor") or (zone == "Ruins of Lordaeron")) then
			inBG = true;
		end
		return inBG;
	end
	function kshot:UpdateAnnounces()
		local Time = GetTime() - lastAnnounceCheckTime;
		while (Time > timePerAnnounce) do
			lastAnnounceCheckTime = lastAnnounceCheckTime + timePerAnnounce;
			Time = GetTime() - lastAnnounceCheckTime;
			if (announces > 0) then
				announces = announces - 1;
			end
		end
	end
	function kshot:getStreakAverage()
		local avgCalc = totalkillingblows/killingstreaktimes;
		if (totalkillingblows == 0) then
			avgCalc = 0;
		end
		return avgCalc;
	end
	function kshot:getStreakMessage(victim, streak)
		local theKillingblowMessage = killingblowMessage;
		theKillingblowMessage = string.gsub(theKillingblowMessage, "$v", victim);
		theKillingblowMessage = string.gsub(theKillingblowMessage, "$s", streak);
		return theKillingblowMessage;
	end
-- needed crap ===========================================================================================================


-- streak announcements ==================================================================================================
	function kshot:EchoStreak(toSelf, Guild, Raid, BG)
		local msg = " current streak is: " .. killingstreak;
		
		if (toSelf == true) then
			kshot:ScrollText("Your" .. msg, true);
		else
			if (Guild == true) then
				SendAddonMessage("kshot_StreakAnnounceEvent", UnitName("player") .. msg, "GUILD");
				kshot:Print("Your current streak has been sended to your Guild");
			end
			if (Raid == true) then
				SendAddonMessage("kshot_StreakAnnounceEvent", UnitName("player") .. msg, "RAID");
				kshot:Print("Your current streak has been sended to your Raid");
			end
			if (BG == true) then
				SendAddonMessage("kshot_StreakAnnounceEvent", UnitName("player") .. msg, "BATTLEGROUND");
				kshot:Print("Your current streak has been sended to your BG");
			end
		end
	end
	
	function kshot:EchoMaxStreak(toSelf, Guild, Raid, BG)
		local msg = " highest streak is: " .. maxkillingstreak;
		
		if (toSelf == true) then
			kshot:ScrollText("Your" .. msg, true);
		else
			if (Guild == true) then
				SendAddonMessage("kshot_StreakAnnounceEvent", UnitName("player") .. msg, "GUILD");
				kshot:Print("Your highest streak has been sended to your Guild");
			end
			if (Raid == true) then
				SendAddonMessage("kshot_StreakAnnounceEvent", UnitName("player") .. msg, "RAID");
				kshot:Print("Your highest streak has been sended to your Raid");
			end
			if (BG == true) then
				SendAddonMessage("kshot_StreakAnnounceEvent", UnitName("player") .. msg, "BATTLEGROUND");
				kshot:Print("Your highest streak has been sended to your BG");
			end
		end
	end
	
	function kshot:EchoAverageStreak(toSelf, Guild, Raid, BG)
		local avg = kshot:getStreakAverage();
		
		local msg1 = " average streak is: " .. avg;
		local msg2 = "Total amount of killingblows: " .. totalkillingblows;
		local msg3 = "Amount of killingstreaks: " .. killingstreaktimes;
		
		if (toSelf == true) then
			kshot:ScrollText("Your" .. msg1, true);
			kshot:Print(msg2);
			kshot:Print(msg3);
		else
			if (Guild == true) then
				SendAddonMessage("kshot_StreakAnnounceEvent", UnitName("player") .. msg1, "GUILD");
				SendAddonMessage("kshot_StreakAnnounceEvent", msg2, "GUILD");
				SendAddonMessage("kshot_StreakAnnounceEvent", msg3, "GUILD");
				kshot:Print("Your average streak has been sended to your Guild");
			end
			if (Raid == true) then
				SendAddonMessage("kshot_StreakAnnounceEvent", UnitName("player") .. msg1, "RAID");
				SendAddonMessage("kshot_StreakAnnounceEvent", msg2, "RAID");
				SendAddonMessage("kshot_StreakAnnounceEvent", msg3, "RAID");
				kshot:Print("Your average streak has been sended to your Raid");
			end
			if (BG == true) then
				SendAddonMessage("kshot_StreakAnnounceEvent", UnitName("player") .. msg1, "BATTLEGROUND");
				SendAddonMessage("kshot_StreakAnnounceEvent", msg2, "BATTLEGROUND");
				SendAddonMessage("kshot_StreakAnnounceEvent", msg3, "BATTLEGROUND");
				kshot:Print("Your average streak has been sended to your BG");
			end
		end
	end
-- streak announcements ==================================================================================================


-- main script ===========================================================================================================
	-- soundfile settings ================================================================================================
		function kshot:GetSoundLink(kills)
			local soundpackNr = "1";
			if (soundpack == "sp1normal") then
				soundpackNr = "1";
			elseif (soundpack == "sp2female") then
				soundpackNr = "2";
			elseif (soundpack == "sp3sexy") then
				soundpackNr = "3";
			elseif (soundpack == "sp4custom") then
				soundpackNr = "4";
			else
				soundpack = "sp1normal";
				soundpackNr = "1";
			end
			
			
			local soundfile = "";
			if (kills > -100 ) then
				if (kills > 19) then soundfile = "sp".. soundpackNr .."-14.mp3";
					elseif (kills > 15) then soundfile = "sp".. soundpackNr .."-13.mp3";
					elseif (kills > 12) then soundfile = "sp".. soundpackNr .."-12.mp3";
					elseif (kills > 10) then soundfile = "sp".. soundpackNr .."-11.mp3";
					elseif (kills >  9) then soundfile = "sp".. soundpackNr .."-10.mp3";
					elseif (kills >  8) then soundfile = "sp".. soundpackNr .. "-9.mp3";
					elseif (kills >  7) then soundfile = "sp".. soundpackNr .. "-8.mp3";
					elseif (kills >  6) then soundfile = "sp".. soundpackNr .. "-7.mp3";
					elseif (kills >  5) then soundfile = "sp".. soundpackNr .. "-6.mp3";
					elseif (kills >  4) then soundfile = "sp".. soundpackNr .. "-5.mp3";
					elseif (kills >  3) then soundfile = "sp".. soundpackNr .. "-4.mp3";
					elseif (kills >  2) then soundfile = "sp".. soundpackNr .. "-3.mp3";
					elseif (kills >  1) then soundfile = "sp".. soundpackNr .. "-2.mp3";
					elseif (kills >  0) then soundfile = "sp".. soundpackNr .. "-1.mp3";
					elseif (kills > -1) then soundfile = "sp".. soundpackNr .. "-0.mp3";
				end;
			else
				if (kills == -114) then soundfile = "sp".. soundpackNr .."-14.mp3";
					elseif (kills == -113) then soundfile = "sp".. soundpackNr .."-13.mp3";
					elseif (kills == -112) then soundfile = "sp".. soundpackNr .."-12.mp3";
					elseif (kills == -111) then soundfile = "sp".. soundpackNr .."-11.mp3";
					elseif (kills == -110) then soundfile = "sp".. soundpackNr .."-10.mp3";
					elseif (kills == -109) then soundfile = "sp".. soundpackNr .. "-9.mp3";
					elseif (kills == -108) then soundfile = "sp".. soundpackNr .. "-8.mp3";
					elseif (kills == -107) then soundfile = "sp".. soundpackNr .. "-7.mp3";
					elseif (kills == -106) then soundfile = "sp".. soundpackNr .. "-6.mp3";
					elseif (kills == -105) then soundfile = "sp".. soundpackNr .. "-5.mp3";
					elseif (kills == -104) then soundfile = "sp".. soundpackNr .. "-4.mp3";
					elseif (kills == -103) then soundfile = "sp".. soundpackNr .. "-3.mp3";
					elseif (kills == -102) then soundfile = "sp".. soundpackNr .. "-2.mp3";
					elseif (kills == -101) then soundfile = "sp".. soundpackNr .. "-1.mp3";
				end;
			end
			return soundfile;
		end
	-- soundfile settings ================================================================================================
	
	-- events ============================================================================================================
		function kshot:CombatLogEventHandler(info, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, param9, param10, param11, param12, param13)
			if (event == nil) then return end
			if (event == "PARTY_KILL") then
				if (destFlags == nil) then return end
				if (sourceFlags == nil) then return end
				if (bit.band(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) == COMBATLOG_OBJECT_AFFILIATION_MINE) then
					if (destName == nil) then return end
					if (bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) == COMBATLOG_OBJECT_TYPE_PLAYER) then
						kshot:KillshotPvP(UnitName("player"), destName);
					else
						kshot:KillshotPvE();
					end
				end
			elseif (event == "UNIT_DIED") then
				if (destName == nil) then return end
				if (destName == UnitName("player")) then
					local Time = GetTime() - lastDamageDealerTimeAgo;
					if (Time > timeBeforeLastDamageDealerResets) then
						lastDamageDealer = "";
					end
					kshot:PlayerDeath(lastDamageDealer);
				end
			elseif (string.find(event, "_DAMAGE")) then
				if (destName == nil) then return end
				lastDamageDealer = sourceName;
				lastDamageDealerTimeAgo = GetTime();
			end
		end
		
		function kshot:AddonMessageHandler(info, prefix, text, type, target)
			if not (target == UnitName("player")) then
				
				-- check if it isn't a multi-send ===================================
					local receiveText = true;
					if (target == lastTextReceivedFrom) then
						local Time = GetTime() - lastReceivedTime;
						if (Time < timeBetweenReceives) then
							receiveText = false;
						end
					end
					
					local receiveSound = true;
					if (target == lastSoundReceivedFrom) then
						local Time = GetTime() - lastReceivedTime;
						if (Time < timeBetweenReceives) then
							receiveSound = false;
						end
					end
				-- check if it isn't a multi-send ===================================
				
				
				receive = "";
				if ((receiveText == true) or (receiveSound == true)) then
					-- receives =====================================================
						-- other ====================================================
							if (prefix == "kshot_StreakAnnounceEvent") then
								if (solo == false) then
									if (receiveText == true) then
										kshot:Print(text);
										receive = "text";
									end
								end
							end
						-- other ====================================================
						-- scrolling text events ====================================
							if (solo == false) then
								if (receiveText == true) then
									if (prefix == "kshot_Guild_Kill_ScrollingTextEvent") then
										if (ReceiveFromGuild == true) then
											kshot:ScrollText(text, false);
											receive = "text";
										end
									elseif (prefix == "kshot_Raid_Kill_ScrollingTextEvent") then
										if (ReceiveFromRaid == true) then
											kshot:ScrollText(text, false);
											receive = "text";
										end
									elseif (prefix == "kshot_BG_Kill_ScrollingTextEvent") then
										if (ReceiveFromBG == true) then
											kshot:ScrollText(text, false);
											receive = "text";
										end
									end
									
									if (OtherDeathMessages == true) then
										if (prefix == "kshot_Guild_Death_ScrollingTextEvent") then
											if (ReceiveDeathsFromGuild == true) then
												kshot:ScrollText(text, false);
												receive = "text";
											end
										elseif (prefix == "kshot_Raid_Death_ScrollingTextEvent") then
											if (ReceiveDeathsFromRaid == true) then
												kshot:ScrollText(text, false);
												receive = "text";
											end
										elseif (prefix == "kshot_BG_Death_ScrollingTextEvent") then
											if (ReceiveDeathsFromBG == true) then
												kshot:ScrollText(text, false);
												receive = "text";
											end
										end
									end
								end
							end
						-- scrolling text events ====================================
						-- sound events =============================================
							if (solo == false) then
								if (receiveSound == true) then
									if (prefix == "kshot_Guild_Kill_SoundEvent") then
										if (ReceiveFromGuild == true) then
											kshot:PlaySound(text);
											receive = "sound";
										end
									elseif (prefix == "kshot_Raid_Kill_SoundEvent") then
										if (ReceiveFromRaid == true) then
											kshot:PlaySound(text);
											receive = "sound";
										end
									elseif (prefix == "kshot_BG_Kill_SoundEvent") then
										if (ReceiveFromBG == true) then
											kshot:PlaySound(text);
											receive = "sound";
										end
									end
									
									if (YourDeathSounds == true) then
										if (prefix == "kshot_Guild_Death_SoundEvent") then
											if (ReceiveFromGuild == true) then
												kshot:PlaySound(text);
												receive = "sound";
											end
										elseif (prefix == "kshot_Raid_Death_SoundEvent") then
											if (ReceiveFromRaid == true) then
												kshot:PlaySound(text);
												receive = "sound";
											end
										elseif (prefix == "kshot_BG_Death_SoundEvent") then
											if (ReceiveFromBG == true) then
												kshot:PlaySound(text);
												receive = "sound";
											end
										end
									end
								end
							end
						-- sound events =============================================
						-- version data =============================================
							if (prefix == "kshot_Guild_VersionCheckRequest") then
								kshot:SendVersionResponse(text, "GUILD");
							elseif (prefix == "kshot_Raid_VersionCheckRequest") then
								kshot:SendVersionResponse(text, "RAID");
							elseif (prefix == "kshot_BG_VersionCheckRequest") then
								kshot:SendVersionResponse(text, "BATTLEGROUND");
							end
							
							if (prefix == "kshot_VersionCheckResponse") then
								local nameLength = string.len(UnitName("player"));
								if (UnitName("player") == string.sub(text, 0, nameLength)) then
									local startIndex = nameLength + 2;
									kshot:Print(string.sub(text, startIndex));
								end
							end
						-- version data =============================================
					-- receives =====================================================
				end
				
				
				-- for multi-send check =============================================
					if (receive == "text") then
						lastTextReceivedFrom = target;
						lastTextReceivedTime = GetTime();
					elseif (receive == "sound") then
						lastSoundReceivedFrom = target;
						lastSoundReceivedTime = GetTime();
					end
				-- for multi-send check =============================================
				
			end
		end
	-- events ============================================================================================================
	
	-- kill / death ======================================================================================================
		function kshot:KillshotPvE()
			if (PvE == true) then
				local soundnr = 0;
				if (PvE_Random == true) then
					soundnr = math.random(1, audiofiles);
					soundnr = 0-100-soundnr;
				else
					killingstreakPvE = killingstreakPvE + 1;
					if (killingstreakPvE > audiofiles) then
						killingstreakPvE = 1;
					end
					soundnr = killingstreakPvE;
				end
				kshot:PlaySound(kshot:GetSoundLink( soundnr ));
			end
		end
		
		function kshot:KillshotPvP(killer, victim)
			if (PvP == true) then
				killingstreak = killingstreak + 1;
				totalkillingblows = totalkillingblows + 1;
				
				if (killingstreak == 1) then
					killingstreaktimes = killingstreaktimes + 1;
				end
				
				if (emote == true) then
					SendChatMessage(kshot:getStreakMessage(victim, killingstreak), "EMOTE");
				end
				
				kshot:ScrollText("You " .. kshot:getStreakMessage(victim, killingstreak), false);
				
				if (killingstreak > maxkillingstreak) then
					maxkillingstreak = killingstreak;
					kshot:ScrollText("You have set a new record!", true);
				end
				
				if (solo == false) then
					if (SendToGuild == true) then
						SendAddonMessage("kshot_Guild_Kill_ScrollingTextEvent", killer .. " " .. kshot:getStreakMessage(victim, killingstreak), "GUILD");
						SendAddonMessage("kshot_Guild_Kill_SoundEvent", kshot:GetSoundLink(killingstreak), "GUILD");
					end
					if (SendToRaid == true) then
						SendAddonMessage("kshot_Raid_Kill_ScrollingTextEvent", killer .. " " .. kshot:getStreakMessage(victim, killingstreak), "RAID");
						SendAddonMessage("kshot_Raid_Kill_SoundEvent", kshot:GetSoundLink(killingstreak), "RAID");
					end
					if (SendToBG == true) then
						SendAddonMessage("kshot_BG_Kill_ScrollingTextEvent", killer .. " " .. kshot:getStreakMessage(victim, killingstreak), "BATTLEGROUND");
						SendAddonMessage("kshot_BG_Kill_SoundEvent", kshot:GetSoundLink(killingstreak), "BATTLEGROUND");
					end
				end
				
				kshot:PlaySound(kshot:GetSoundLink(killingstreak));
			end
		end
		
		function kshot:PlayerDeath(killer)
			killingstreak = 0;
			
			local msg = " got pwned by " .. killer .. "!";
			if (killer == "") then
				msg = " got pwned!";
			end
			
			if (YourDeathMessages == true) then
				kshot:ScrollText("You" .. msg, true);
			end
			if (YourDeathSounds == true) then
				kshot:PlaySound(kshot:GetSoundLink(killingstreak));
			end
			
			if (solo == false) then
				if (SendToGuild == true) then
					SendAddonMessage("kshot_Guild_Death_ScrollingTextEvent", UnitName("player") .. msg, "GUILD");
					SendAddonMessage("kshot_Guild_Death_SoundEvent", kshot:GetSoundLink(killingstreak), "GUILD");
				end
				if (SendToRaid == true) then
					SendAddonMessage("kshot_Raid_Death_ScrollingTextEvent", msg, "RAID");
					SendAddonMessage("kshot_Raid_Death_SoundEvent", kshot:GetSoundLink(killingstreak), "RAID");
				end
				if (SendToBG == true) then
					SendAddonMessage("kshot_BG_Death_ScrollingTextEvent", msg, "BATTLEGROUND");
					SendAddonMessage("kshot_BG_Death_SoundEvent", kshot:GetSoundLink(killingstreak), "BATTLEGROUND");
				end
			end
		end
	-- kill / death ======================================================================================================
-- main script ===========================================================================================================


-- used functions ========================================================================================================	
	function kshot:Test()
		local killingstreaktest = math.random(1, 25);
		if (emote == true) then
			SendChatMessage(kshot:getStreakMessage("TEST", killingstreaktest), "EMOTE");
		end
		kshot:ScrollText("You " .. kshot:getStreakMessage("TEST", killingstreaktest), false);
		kshot:PlaySound(kshot:GetSoundLink(killingstreaktest));
	end
	
	function kshot:CheckVersions(Guild, Raid, BG)
		kshot:Print(UnitName("player") .. " is on version " .. version);
		if (Guild == true) then
			kshot:CheckGuildVersions();
		end
		if (Raid == true) then
			kshot:CheckRaidVersions();
		end
		if (BG == true) then
			kshot:CheckBGVersions();
		end
	end
	
	function kshot:EchoStreakData(what, Guild, Raid, BG)
		if ((Guild == false) and (Raid == false) and (BG == false)) then
			kshot:Print("You can't send your streak-data to no-one!");
		else
			kshot:UpdateAnnounces();
			announces = announces + 1;
			if (announces < maxAnnounces) then
				if (what == "streak1") then
					kshot:EchoStreak(false, Guild, Raid, BG);
				elseif (what == "streak2max") then
					kshot:EchoMaxStreak(false, Guild, Raid, BG);
				elseif (what == "streak3avg") then
					kshot:EchoAverageStreak(false, Guild, Raid, BG);
				else
					sendwhat = "streak1";
				end
			else
				kshot:Print("Killsot's Anti-Spam stopped your streak-data announcement!");
			end
		end
	end
	
	function kshot:ResetStreak()
		killingstreak = 0;
		killingstreakPvE = 0;
		kshot:Print("Your Killshot streak has been resetted");
	end
	
	function kshot:ResetStreakInfo()
		killingstreak = 0;
		killingstreakPvE = 0;
		maxkillingstreak = 0;
		totalkillingblows = 0;
		killingstreaktimes = 0;
		kshot:Print("Your streak data has been deleted");
	end
	
	function kshot:ResetAll()
		saved = currentSavedVar;
		
		soundpack = "sp1normal";
		killingblowMessage = "pwned $v! Streak of $s!";
		
		sound = true;
		scrollingtext = true;
		emote = true;
		solo = false;
		
		PvP = true;
		PvE = false;
		PvE_Random = false;
		
		ResetStreakOnLogin = false;
		ResetStreakOnZoneChange = false;
		
		sendwhat = "streak1";
		StreakAnnounceGuild = true;
		StreakAnnounceRaid = true;
		StreakAnnounceBG = true;
		
		SendToGuild = true;
		SendToRaid = true;
		SendToBG = true;
		ReceiveFromGuild = true;
		ReceiveFromRaid = true;
		ReceiveFromBG = true;
		ReceiveDeathsFromGuild = true;
		ReceiveDeathsFromRaid = true;
		ReceiveDeathsFromBG = true;
		
		CheckVersionGuild = true;
		CheckVersionRaid = true;
		CheckVersionBG = true;
		
		YourDeathMessages = true;
		YourDeathSounds = true;
		OtherDeathMessages = true;
		OtherDeathSounds = true;
		
		killingstreak = 0;
		killingstreakPvE = 0;
		maxkillingstreak = 0;
		totalkillingblows = 0;
		killingstreaktimes = 0;
		kshot:Print("Killshot detected a new user"); 
	end
-- used functions ========================================================================================================